Subject: Re: WARNING FOR PINE 3.90 USERS!!!!!

From: [email-masked] (D. Linford)
Date: 4 Oct 1994 12:17:21 -0700

In article <[email-masked]>,
R. Stewart Ellis <[email-masked]> wrote:
>
>Please make it configurable, and make the default to treat mail as private.
>I can think of almost no case where it is appropriate to post back to news
>something that I have received in private mail.

	There many times when someone posts a message to a group which
they don't follow. They request responses via email. Many times it
would be appropriate to initially send to the newsgroup as well. I
wonder if the problems is that there is insuficient information in the
headers for the pine to determine if the message was posted, as well
as mailed.

d
-- 
---- D.Linford ----- Van.BC ----
---- [email-masked] --------

---

From: David L Miller <[email-masked]>
Date: Tue, 4 Oct 1994 20:11:32 -0700 (PDT)

It seems from discussions with other users that the problem is that some
(many?) newsreaders supply too much information when replying via mail.  That
is, they include a Newsgroups: header even though the message was not posted
to the newsgroup!  Pine sees the Newsgroups: header and assumes that the
message was posted as well as mailed.  AFAIK, there is nothing that Pine can
do to tell that the Newsgroups: header is a lie... 

|\ |  |\/|  David L. Miller    [email-masked]  (206) 685-6240
|/ |_ |  |  Software Engineer, Pine Development Team   (206) 685-4045 (FAX)
University of Washington, Networks & Distributed Computing, JE-20
4545 15th Ave NE, Seattle WA 98105, USA

---

From: [email-masked] (Neil Rickert)
Date: 4 Oct 1994 23:06:44 -0500

In <[email-masked]> David L Miller <[email-masked]> writes:

>to the newsgroup!

This is not "too much information."  The newsgroups header on email
is informative, and what else is the purpose of information but to
be informative.

>                   Pine sees the Newsgroups: header and assumes that the
>message was posted as well as mailed.

Then Pine is stupid for making such an assumption.

>                                       AFAIK, there is nothing that Pine can

The "Newsgroups:" header is not a lie.  There is nothing in RFC822 which
forbids a "Newsgroups:" header in email.  The header informs the email
recipient as to the origin of the discussion.

---

From: Nancy McGough <[email-masked]>
Date: 6 Oct 1994 00:59:53 GMT

Since Pine 3.90 is the first widely used Mailer-and-Newsreader-in-one, 
it makes sense that it's dealing with header issues that haven't been 
an issue before.

Ideally when a message is received in mail you would be able to tell
whether it was mailed only or both posted and mailed.  That way when
you reply you would know whether it is appropriate to reply by posting
as well as mailing.  (Proper netiquette is to not post private mail.)
Currently I don't think there's any uniform way to determine this from 
the headers (please let me know if there is).

It would be nice if there were standard headers for both mail and news
messages which told:
[1] where the message was mailed (except Bcc)
[2] where the message was posted
[3] where the message originated, i.e., if it's a reply or forwarded
    message where the message that is being replied to or forwarded
    was (newsgroup(s), mailing list(s), non-mailing-list mail)

To:_ and Cc:_ mean [1] most of the time, but some posted messages
might have these headers and not actually have been mailed to the
folks on the To:_ and/or Cc:_ lines.  This would happen with a 
newsreader that doesn't honor To:_ and/or Cc:_ lines and doesn't strip 
them out.

For posted messages Newsgroups:_ satisfies [2].  For mailed messages
Newsgroups:_ sometimes means [2] only, sometimes means [3] only,
and sometimes means [2] and [3].

For the future it might be a good to have standard headers for both
mail and news for [2] and [3].  What do people think?  Of course anything 
adopted would have to be backward compatible with existing RFCs.  

Looking forward to a discussion,
Nancy
(not affiliated with the pine team; ex newsreader designer)

--

 **  **    Nancy McGough             |  "No one suspects the
*  **  *   Infinite Ink              |   days to be gods."
 **  **    ftp://ftp.ii.com/pub/ii   |                     -Emerson

---

From: [email-masked] (Neil Rickert)
Date: 5 Oct 1994 21:48:41 -0500

>it makes sense that it's dealing with header issues that haven't been 

The particular issue should not be an issue now.  It is because of a
design flaw in pine.  Let's not try to reinvent the world just to
avoid admitting that this is a design flaw.

>whether it was mailed only or both posted and mailed.

If you received the message in mail, then it was mailed.  If you want to
know whether the originator of the message also posted it in a public
forum somewhere -- then you are asking for the ability to read minds
of people you have never met.  That is impossible.

>                                                       That way when

If you received the message by mail, and there is no indication that
it was also posted, proper netiquette is to assume that it was mail.
You do not need any special headers for that.

>the headers (please let me know if there is).

One can make intelligent guesses.  Cnews and INN have distinctive
message IDs which strongly suggest that the message originated
in news.  But it would be unwise to count on this.

>[1] where the message was mailed (except Bcc)

Why not consider usenet posting as equivalent to "Bcc: everybody".  That
way you can treat it as mail, and your ignorance that it was posted
completely conforms to your desired ignorance as to the content of
the Bcc: addresses.

>    was (newsgroup(s), mailing list(s), non-mailing-list mail)

Usually the "Received:" header in mail and the "Path:" header in
usenet news can give you this information.

>newsreader that doesn't honor To:_ and/or Cc:_ lines and doesn't strip 

That happens.  It can also happen with email.  It is quite easy to
create an email message with "To:" and "Cc:" headers which do not
correspond to actual recipients.  I suppose this is no worse than a
person sending a paper letter addressed to his lawyer with a "Cc:" to
another person, but the letter is only sent to the other person and
not to the lawyer.

>and sometimes means [2] and [3].

"Newsgroups:" has a defined meaning for usenet, but has no defined
meaning for email.  As a result, people are allowed to use it for
whatever they like.  I prefer to retain the "Newsgroups:" header in
email replies to postings, and sometimes even in email replies to
email that has a "Newsgroups:" headers, and presumably originated on
usenet.

>adopted would have to be backward compatible with existing RFCs.  

Perhaps.  But you will probably never get it adopted.  There are too
many existing products which do not honor these to-be-invented
headers, and most people are satisfied with things the way they are.

---

From: Mark Crispin <[email-masked]>
Date: Wed, 5 Oct 1994 20:04:24 -0700

> recipient as to the origin of the discussion.

Strictly speaking, headers which are not specified defined by RFC822 are 
either a ``extension-field'' or ``user-defined-field''.  There are two 
differences between these two:
 1) extension-field is one that is officially registered, and never begins
    with X-.
 2) user-defined-field is any name that is not an RFC822 field or an
    extension-field, and may begin with X-.  Any user-defined-field which
    does not begin with X- may be preempted by an extension-field 
    definition at any time.  By definition, a user-defined-field is
    private and may be interpreted by each implementation as it wishes.

There is no definition of an extension-field of Newsgroups: in the RFC822
context.  It is defined as a *news* field, but that is a separate context
from RFC822 and in fact an entirely different protocol specification.

Consequently, in the RFC822 context it is a user-defined-field.  An RFC822
implementation can do whatever it pleases with any user-defined-field! 

Pine treats the RFC822 context user-defined-field of Newsgroups:  as being
identical to the news context field of Newsgroups:.  Your claim is that
the interpretation of Newsgroups: is different in mail than it is in news. 
There is nothing in the protocol specifications to support your position
or, for that matter, Pine's position; it is up to each implementation. 

This does not mean that the *suggestion* to treat Newsgroups: differently
when reading mail than when reading news is rejected.  I am not aware of
any decision being made either way.  However, whether it is accepted or
rejected will be on its own merits, and not by virtue of a claim that the
specifications say something that they don't.

---

From: [email-masked] (Neil Rickert)
Date: 6 Oct 1994 00:10:38 -0500

>    private and may be interpreted by each implementation as it wishes.

Agreed.

>identical to the news context field of Newsgroups:.

No, that is not correct.  The RFC1036 (news context) only supplies an
interpretation of "Newsgroups:" when it appears in a news article.  RFC1036
does not provide any interpretation of "Newsgroups:" when it appears
in an email message.  If Pine assigns an interpretation to "Newsgroups:"
in an email message, that is Pine's own invention, and it is not in
any way taking the RFC1036 interpretation.

Now perhaps you can say that Pine treats "Newsgroups:" in mail as
analogous to its use in usenet, but you cannot say that it treats
it identically.

>                                                     Your claim is that

Yes, of course the interpretation is different.  There is an
interpretation in news, and there is no interpretation in mail.  If
you don't think that is different, then your way of thinking is quite
strange.

>or, for that matter, Pine's position; it is up to each implementation. 

I agree that the protocol does not specify.  That is why it was wrong
of a previous author to say that the Newsgroups: line in mail was a
lie.

>when reading mail than when reading news is rejected.  I am not aware of

If the author's of Pine want to treat "Newsgroups:" the way they
do - that is their choice.  I have no particular position for
or against this.  I object to them labelling the appearance of
"Newsgroups:" in mail as a lie.  Generally speaking, when there is
no rule, one goes by the common practice, and the common practice
for some time has been for email responses to news to include the
"Newsgroups:" header.  Thus the header has a meaning by an
analogue of common law.  If the Pine author's wish to change this,
they should ideally go the RFC route to do so.  I think such an
attempt would fail, but they have the right to try.

Right now the Pine authors are in the position of the soldier
marching out of step with the rest of the brigade, but declaring that
he is in step and everybody else is out of step.  If the Pine authors
can persuade the rest of the world to fall in step with them -- good
luck to them.  But let's not distort the picture.  They made an
unwise design decision which has embarrassed several users, and they
should not try to shift the blame.

Personally, I don't care very much.  I install Pine because some of
my users ask for it.  Except for testing the installation, I do not
use Pine.  I consider it to be one of the biggest pieces of junk
software and poor design that I have encountered.

---

From: [email-masked] (John Stanley)
Date: 6 Oct 1994 15:06:08 GMT

>newsreader that doesn't honor To:_ and/or Cc:_ lines and doesn't strip 

Proper newsreader [sic] behaviour is to ignore To: and CC: headers. They
are undefined and thus should be ignored.

>For mailed messages

Proper mailer behaviour is to ignore Newsgroups: headers. The fact that
brain damaged newsreaders leave them in when composing mailed replies is
not reason to change the current definitions of mail. 

>adopted would have to be backward compatible with existing RFCs.  

The proper course of action is to modify the newsreader software to
include a "post and mail" command. The mailed copies get mail headers,
the posted ones get news headers. 

In no case should a user wind up surprised that his mail got posted by
some intermediate site just because there was an undefined Newsgroups:
header in it, nor should the opposite surprise exist (a copy mailed when
a posted article has an undefined To: header in it.)

(In case you want to claim that that would never happen, I can tell you
of at least one case where in-transit mail was processed by a mailer
which noticed a user name of the form usenet.group.name, and, ignoring
the small detail that it was not the host to whom the mail was
addressed, went ahead and posted the mail. In most cases, this is the
intended result, but in my case it was not. This intermediate mailer had
been in operation for a long time before I caught it doing this; how many
others are there that haven't been?)

This rules out suddenly defining the To: header in news, or the
Newsgroups: header for mail, to mean "inject this package into the other
type of stream".

At best, it means the originating newsreader inserting an
"X-Also-Mailed-To:" or "X-Also-Posted-To:" header in the generated
packages.

---

From: Nancy McGough <[email-masked]>
Date: 6 Oct 1994 15:08:56 GMT

[email-masked] (Neil Rickert) writes:
>I install Pine because some of

I'm curious why you think this.  Could you please post at least 3 features 
(other than the Newsgroups:_ header in a mail message) which you think were 
poorly designed and mailers that do each of these 3 features better.

Thanks,
Nancy

--

---

From: [email-masked] (Neil Rickert)
Date: 6 Oct 1994 13:06:22 -0500

>poorly designed and mailers that do each of these 3 features better.

   1:	It is a bitch to install.

	Read the instructions.  Select the configuration for
	your system, using the 'gcc' compiler.

	Run the build script.  Discover that it doesn't
	use the 'gcc' compiler.

	Read and understand the build script, so that you can
	really use 'gcc', by adding a keyword argument CC=gcc
	on the command line.  Discover that it does a half-baked
	job, using 'gcc' part of the time, and 'cc' part of the
	time.

	Use a 'find' to locate all of the 'Makefile's to find what
	has to be changed to really use gcc.

	Compile.  Have the thing crap out in the middle because a
	system include file is included twice, the first time with
	'const' as itself, and the second time with 'const' redefined
	as ''.

	Build it.  Discover that it makes incorrect assumptions
	about where various things are in your system (such as
	the news active file).  Grep through every directory till
	you find what has to be changed.

	etc.

   2:   It is excessively obese.

	The stripped binary is significantly in excess of 1 meg in
	size.  Much of this is due to the inclusion of help text
	within the binary instead of in a separate help file.  This
	means that an experience user who need no help must
	nevertheless load the help information into memory whenever
	she uses the software.

   3:	It screws up message status of the default mailbox.

   	It always opens my default mailbox, whether I want it to
	or not.  The status of messages in that mailbox changes
	from New to Unread, even though I have not asked to
	read the mailbox, and have not seen the list of messages
	in that mailbox.

   4:	The menu interface is tedious and unintuitive.

   	When reading news, it displays a humongous list of newsgroups
	for me to select from.  I have to actually select each in turn
	to discover that there are no unread messages in that newsgroup.

	After reading one newsgroup, if I want to select another I
	must go back and re-select the news collection, and have it
	redisplay the menu, then I must page through the menu to
	about where I was.  Perhaps I am missing some shortcut here,
	but the keypresses indicated on the screen display do not
	provide a shorter alternative.

   5:	Poorly timed user unfriendly prompts.

	If I read my mail, then spend some time reading usenet, at
	the end it asks me if I really wanted to delete those
	messages from my mailbox.  But that might be so long after I
	asked to delete them that I have forgotten the details.  If
	the program wants to second guess and ask for confirmation,
	it should do it much earlier, perhaps as soon as a different
	folder is selected.

Sorry, but there is no point in my listing other mail programs which
do not have these faults.  I am not aware of any other mail programs
which do have these faults.

---

From: Nancy McGough <[email-masked]>
Date: 6 Oct 1994 21:17:19 GMT

The suggestions for new headers came from me (an avid news and mail user 
who years ago designed a newsreader that was never developed) so it's not 
so much that Pine cares about these things, it's that I care and I thought
others might too....

For the sake of discussion suppose the headers are called:
  X-Posted-To: 
  X-Response-To-Message-In: 

And suppose I receive a message with these headers (plus some other
headers) in my mailbox:
  From: abrahamp
  To: nancym
  Cc: peterg
  Subject: Re: How Experiments End
  Newsgroups: soc.history.science
  X-Posted-To: soc.history.science
  X-Response-To-Message-In: soc.history.science,sci.philosophy.tech

Because of the X-Posted-To: header I know that abrahamp both posted and 
mailed his message so it is ok (acceptable netiquette) for me to both 
mail and post my response.  Because of the X-Response-To-Message-In:
header I know that he is responding to a message that was crossposted
to soc.history.science and sci.philosophy.tech so I can go take a look
at both these newsgroups to read the discussion.  Since crossposted
discussions often bifurcate its useful to know all the newsgroups
the message that's being replied to was in.  

Does this seem useful to anyone else?

Also, I'm curious which other mailers allow users to simultaneously mail
and post.

Thanks much,
Nancy

PS to people reading this on the header-people mailing list (which is 
linked to comp.mail.headers): If possible could you post your response 
to all the newsgroups that are participating in this discussion. Thanks.

In comp.mail.headers [email-masked] writes:
>The Andrew Message System has been dealing with netnews and mailings
>since about 1987.  We've had no problems with the concept of one message
>reader dealing with both.
>
>On the face of it, I have to wonder what Pine cares about where a
>message was read or posted.  What difference does it make to the reader?
> (``Disclaimer: the displayed message came from NetNews; read at your
>own risk'' in a red border around the screen?)
>
>If Pine is all that worried, it could in principle use
>out-of-incoming-header information to decide how a message got into its
>hands, like whether it's reading from a folder of filed mail, from an
>in-box, or from a newsgroup repository.  AMS installations that deal in
>netnews usually add a special message header to tell the reader to what
>address ``wide replies'' (e.g. reply-to-all) should be directed, but a
>simpler alternative would be for there to be tags in the AMS reader
>configuration, or in the folder tree itself, indicating what parts of
>the message database hold netnews messages as distinct from mailed
>messages.
>
>The argument is similar to that of the Content-Length: one, in that if a
>mail reader is going to rely on some non-standard (possibly
>non-standardizeable) features of incoming mail, then it should itself
>assure that it will be able to use those non-standard features.
>
>Thus, I vote against amending the standards to restrict what can be said
>in a mail header.
>
>		Craig

--

---

From: Nancy McGough <[email-masked]>
Date: 6 Oct 1994 22:57:31 GMT

>not reason to change the current definitions of mail. 

I just tested TRN 3.5, TIN 1.2 PL2, NN 6.4.18, and PINE 3.90 by using
the r command to respond in mail to a USENET article.  TRN, TIN, and NN 
all included a Newsgroups: header in a mailed response to a news article.
Pine 3.90 did not include a Newsgroups: header when the response was
mailed only.  Do you really think that TRN, TIN, and NN are brain damaged?

It seems clear that if there is going to be a standard header that means
that a mail message was simultaneously mailed and posted it will have
to be something other than the Newsgroups: header.  What do people think
of Posted-To:?

Thanks,
Nancy

--

---

From: Roman Czyborra <[email-masked]>
Date: Fri, 07 Oct 1994 01:11:20 +0100

> design flaw in pine.

I disagree, I'd call rn's reply behavior ignorant of RFC 1036.

> of people you have never met.

I have had one person get mad at me once: I mailed him a copy of my
followup on his posting and he replied privately.  Later he saw that I
had also posted my message so he had to go back into his archive and
manually post the answer he had sent to me.  Consequently I renamed
Newsgroups: to Also-Posted-To: for a while.  The Also- prefix was
inspired by the son-of-rfc1036 draft.  Now that I've seen Pine use
Newsgroups: as an indicator for postings I've returned to sending out
that header.  Sam Tardieu uses To-Newsgroups.

Instead of reading minds, one could of course query the NNTP server
for the message-id, but postings may not arrive there soon enough.

> You do not need any special headers for that.

If you want to automatize things, you need a standardized label which
indicates a public posting.  The same problem arises for newsgroup
moderators who have to decide whether a message con Newsgroups: was
meant as a private reply or a public submission.

> usenet news can give you this information.

Many mailers and newsreaders consider Path: and Received: clutter
and do not include it in forwarded messages.  Anyway, these lines
tell you how the message made it to you, not where it originated.

I've been using Old-Newsgroups: and Old-To: to indicate the origin of
a conversation occasionally, that prefix was inspired by formail.

> meaning for email.

You also believe that Content-Type: is undefined in news just because
RFC 1521 doesn't mention Usenet?

> But you will probably never get it adopted.  There are too many
> existing products which do not honor these to-be-invented headers

Yes, unfortunately Newsgroups in replies has become very common
and Pine3.90 alone does not produce enough pressure on people who
want to keep their replies private to fix their newsreaders.

---

From: [email-masked] (Eigil Krogh Sorensen)
Date: 7 Oct 1994 00:20:29 GMT

>which do have these faults.

Well, try to write danish charaters in those other mail programs
you mean are so good and send that mail from unix and read it
on a PC :-) 

Do the same with one or another kind of document made by one or
another programme.

Then after that please tell me which of your mail programs I can
get for free and that can do the same that easy :-)

Eigil

---

From: Roman Czyborra <[email-masked]>
Date: Fri, 07 Oct 1994 03:06:14 +0100

Neil> I consider it to be one of the biggest pieces of junk
Neil> software and poor design that I have encountered.

> I'm curious why you think this.

The UW folks have implemented many neat features, some a tad
overbearing, but most of them are safe and easy to use and well
documented, both for beginners and experienced users. Pine definitely
excels in this area.

However, when you look at the monstrous sources, you will find a lot
of debatable clutter making pine larger and slower than necessary and
hard to overview and maintain.  Once you need to make some adaptations
to your local environment you start to wonder why things like the path
to your news spool or the newmail poll time aren't organized in one
single config.h for all architectures or at least all flavors of Unix.

---

From: [email-masked] (Russell Schulz)
Date: Thu, 6 Oct 1994 21:30:44 -0600

> Since Pine 3.90 is the first widely used Mailer-and-Newsreader-in-one, 

read:  `most widely used to date'.  Andrew does this.  GNUS does this.
this (non-widely-used) package does this.

> Right now when Pine is viewing a message in a mail folder (i.e., inbox
> or save-folder) it assumes that a To:_ header means the message was 
> mailed and a Newsgroups:_ header means the message was posted, and both 
> mean the message was both posted and mailed.

this is obviously wrong.  it should be fixed.
-- 
Russell Schulz  [email-masked]  ersys!rschulz  Shad 86c

---

From: "Steven D. Majewski" <[email-masked]>
Date: Fri, 7 Oct 1994 12:40:31 -0400 (EDT)

Pine is clearly doing (more or less) the "Right Thing" here. 

Once a message has been moved - from either INBOX (mail) or 
from the news spool or nntp-server into another folder, all 
a mail/news-reader has to go on is what's in the header. 

The scheme Neil Rickert suggest would break under these conditions. 
( When I get replies on a query I've posted, I usually save them,
 whether they were posted replies or mail replies into a topic
 specific folder. I don't want to have to switch back and forth 
 between folders when I'm working on a summary or other replies. )
How can a program tell if it was a posted or e-mailed reply, other
than trying to infer from the headers?  

Inference isn't perfect, so it does have to ask for confirmation - 
and maybe that message could be made more clear. 

I'm not sure what it does to outgoing Newsgroups: header lines 
in all cases. I think it ought to propagate this info, even if
the user doesn't post his reply. However, this will obviously
make any inference even less likely to be true. 

Perhaps there does need to be some new header or convention defined. 

My newsreaders also allow a Cc: address, and they will mail AND 
post a reply if that is filled in. If I'm posting a reply to someone,
I often CC: them personally as a courtesy. I always appreciate it
when someone does the same - I don't always follow news every day, 
even if I've posted a message, so getting an email-reply of a message
that is also posted is quite helpful. But, I have also gotten remarks
from folks who don't like this double-reply. They always assume if 
they get a response in the mail, that it is a non-public response, 
and they reply by email; then get anoyed when they see also see my
message show up in news. There is really no consensus about proper 
e-mail ettiquite is this matter - so maybe there needs to be a better
convention for indicating all these cases clearly. ( and note that
this is another case that "breaks" Neil Rickert's scheme. ) 

-- Steve Majewski       (804-982-0831)      <[email-masked]> --
-- UVA Department of Molecular Physiology and Biological Physics --
-- Box 449 Health Science Center        Charlottesville,VA 22908 --
		 [ "Cheese is more macho?" ]

---

From: [email-masked] (John Stanley)
Date: 7 Oct 1994 14:45:38 GMT

>mailed only.  Do you really think that TRN, TIN, and NN are brain damaged?

If they leave Newsgroups: headers in mail they generate, yes. They are
inserting undefined headers.

>that a mail message was simultaneously mailed and posted it will have

You mean, like, the X-Also-Posted-To: I suggested?

---

From: [email-masked] (Chris Hedley)
Date: 7 Oct 1994 13:15:43 +0100

>    1:	It is a bitch to install.

No more so than any other public domain software.  In my experience, Pine
was one of the easier packages to install that wasn't developed specifically
for my type of system.  Having to redefine the compiler type does not
seem to me to be a major effort, especially bearing in mind some of the
far more serious problems I have encountered with other packages; doing
some minor tweaking to the makefiles is no big thing when you
consider the amount of work that has gone into a program of this scale
which is then freely distributed!

>    2:   It is excessively obese.

Not a problem on demand-paged systems such as Unix and VMS, which are
the most common platforms for Pine.  Your claim that the help information
must be loaded into memory whenever the software is used is incorrect.

> 	read the mailbox, and have not seen the list of messages

I haven't noticed it trying to open the default mailbox if I specify an
alternative on the command line.  As for changing the status of new messages
to unread, every mailer I have used does this (correctly in my opinion).

>    5:	Poorly timed user unfriendly prompts.

These are your opinions.  Whilst you are entitled to them, please
don't use them as reasons to substantiate your claim that the software
is "junk".  My opinion (which is independant, I have no connection with
the Pine development team) is that Pine 3.90 is by far the best character-
cell based mailing system available for Unix platforms that I have used,
combining a large number of powerful features with an easy to use and
pleasant user interface.  And it's free.
Cheers,

Chris.

---

From: Roman Czyborra <[email-masked]>
Date: Fri, 07 Oct 1994 21:32:50 +0100

> >The fact that brain damaged newsreaders leave them in when
> >composing mailed replies is not reason to change the current
> >definitions of mail.

> Do you really think that TRN, TIN, and NN are brain damaged?

In TRN it is only the default $MAILHEADER format which can be changed
real easy. So chalk trn up with pine and xrn and the brain damage
prevalence drops to 50 %.

> to be something other than the Newsgroups: header.  What do people think

Unlike Newsgroups Posted-To has the disadvantage that most of the
currently existing integrated mail and news readers would ignore it.

I also find it more beautiful for the same information to have the
same name in news and mail.  After all, you do not have to rename
From, Subject, Date & Co. either when gating between mail and news.

---

From: [email-masked] (Neil Rickert)
Date: 7 Oct 1994 16:29:51 -0500

>a mail/news-reader has to go on is what's in the header. 

The saved messages are separated by a "From " line.  News articles
have no "From " line.  Therefore Pine must create that line.  It
could easily create it in a special format which Pine recognizes as
indicating a news article.

---

From: Terry Gray <[email-masked]>
Date: Fri, 7 Oct 1994 18:51:55 -0700 (PDT)

On 7 Oct 1994, Neil Rickert wrote:
>
> >"Steven D. Majewski" writes:
> The saved messages are separated by a "From " line.  

Depends on the folder format.  The "From " separator line of course is 
not part of the message.

> News articles have no "From " line.  

They may, in the same sense that mail messages do.  All of the 
newsreaders I use (rn, trn, etc) save in mbox format and have "From " 
separator lines.  You obviously prefer a different configuration.

> Therefore Pine must create that line.  

The tool that stored the message created that line. This may or may not
have been Pine.

> It could easily create it in a
> special format which Pine recognizes as indicating a news article. 

Sorry, but there is no dependable context for making any such assumption,
especially when the same message might really have been both mailed and 
posted.  Pine gets whatever it is given, and that may be a message in any 
of a dozen different mailbox formats, created by any one of many different 
tools. As was said previously: you have only the message headers to go on.

But let's talk about *assumptions*.  A lot of this thread contains strong
criticism of Pine that is based on *assumptions* (not facts) about whether
Pine is making unwarranted *assumptions* about what to do with messages
containing a newsgroups header. 

In fact, Pine does not assume anything in this situation.
It asks the user what they want to do.  More than once.

Here's exactly what happens when I Reply to a message that contains a 
Newsgroups header:

 1. Pine prompts me with:  "Post follow-up message to news group(s)? "
    (the default is NO)
 2. If I say Yes, then it clearly shows all the newsgroups in the composer.
 3. If I then ^X to send, Pine makes sure that the headers are visible
    on the screen so I can re-check where the msg is going, then it asks 
    for confirmation... If I confirm, and there is a Newsgroups header, 
    I then get an ADDITIONAL prompt:
 4. "Posted message may go to thousands of readers. Really post?"
    (the default is NO)

Given that it is impossible to correctly *assume* the correct action in
such situations, what would you have Pine do differently?

-teg

---

From: David L Miller <[email-masked]>
Date: Fri, 7 Oct 1994 16:27:19 -0700

On 7 Oct 1994, Neil Rickert wrote:

> Date: 7 OCT 1994 16:29:51 -0500 
> From: Neil Rickert <[email-masked]>
> Newgroups: comp.mail.pine
> Subject: Re: Headers of Simultaneous Mail & News (was: WARNING FOR PINE 3.90 USERS!!!!!) 
> 

That is only in one mailbox format, and besides, what if it is saved from
TRN?  It doesn't know this magic incantation...

---

From: Terry Gray <[email-masked]>
Date: Fri, 7 Oct 1994 20:50:00 -0700

-teg

---

From: [email-masked] (Wayne Davison)
Date: Sat, 8 Oct 1994 04:05:30 GMT

According to Nancy McGough  <[email-masked]>:
> Because of the X-Response-To-Message-In: header I know that he is
> responding to a message that was crossposted to soc.history.science
> and sci.philosophy.tech so I can go take a look at both these newsgroups
> to read the discussion.

In my mind this is the existing function of the Newsgroups header in
a mailed newsarticle (where was the discussion occurring that prompted
this message), thus your Newsgroups header could have been set to the
two newsgroups, the X-Response-To-Message-In header eliminated, and the
X-Posted-To (or Also-Posted-To would be nice) providing the information
that it is ok to reply via mail and newsgroup.
-- 
Wayne Davison
[email-masked]

---

From: [email-masked] (David Herron)
Date: 8 Oct 94 01:33:33 GMT

Oh yeah .. a couple details:

In PathWay Access/Mail (not technically the right name for the product)
when "replying" to a message the action taken varied depending
on which folder you were in.  i.e. whether it was a News message
or Mail message.

News:	Ask whether to post followup or send mail.
	If sending mail whether to reply to everybody or just sender.
	Ask whether/how to include text in reply.

Mail:	Ask whether to reply to everybody or just sender.
	Ask whether/how to include text in reply.

		David

---

From: Chris Newman <[email-masked]>
Date: Sat, 8 Oct 1994 12:10:04 -0400

[email-masked] (Wayne Davison) writes:
> this message)

Please point to a formal specification which defines "Newsgroups" with
such a meaning.  The only specification I know of defines the
"Newsgroups" header as a list of newsgroups to which the message was
posted.  Any other use of that header is a violation of that spec and
is misleading in situations where news & mail can't be distinguished.
Besides, it's obviously bad practice to have the same header have two
different meanings.

		- Chris Newman
		Carnegie Mellon University Computing Services

---

From: Michael Seibel <[email-masked]>
Date: Fri, 7 Oct 1994 22:27:56 -0700

Neil,

Thanks for the thoughtful clarification; you bring up some valid points.
Specific comments such as these go a long way toward making Pine a better
product.  I'll not try to duplicate other's comments from this thread, but
to provide some word from the Pine Team on the underlying motivation for
what you found. 

It's unfortunate that your initial Pine experience was in an environment
Pine was not specifically designed to fit.  We don't actively develop
under SunOS or Solaris, but when work is done, it's based on the native
compilers.  Our goal is, of course, to keep the scripts, makefiles, and
code as portable and general as possible, but, as always, there is room
for improvement.  We will do our best, as time permits, to remedy this
situation. 

What Pine *is* designed to be is as equally non-threatening to *both* the
neophyte user and the neophyte system administrator.  With the latter in
mind, it is deemed more useful to group configuration data requiring local
modification, both OS-dependent and not, in a single location rather than
require an unfamiliar sys-admin to scan several files before becoming
confident (OK, semi-confident) that Pine will behave in a desired way.  We
hold that the sophisticated sys-admin in a heterogenous environment
already has the tools to deal with this case. 

Of course, it's clear we've not completely tackled the single-config
challenge, as there are pieces of the Pine puzzle that were initially and
continue to be developed independent of Pine.  Likewise, with this goal in
mind, it isn't clear to us that the problems self-configuring tools can
introduce offset their usefulness in our situation.  Thus, this avenue was
also not taken. 

Furthermore, we feel ease of configuration should extend to installation
as well.  That's why Pine on Unix is obese.  The fewer auxiliary files an
unfamiliar sys-admin is required to position in just the right place the
better.  This is key during both the initial installation and subsequent
upgrades.  Another reason is that we distribute pre-compiled copies of
each release.  A single binary is much simpler to fetch and install than a
tar'd package of several files to, in turn, get deposited throughout the
system. 

As for your other points, I'll concede that, for a seasoned, knowledgeable
user, some of Pine's behavior may seem less than efficient.  However, very
few user interface decisions are considered outside the context of the
fundamentals we see as requisite of a tool intended for the novice user. 
In short, this means fewer commands, more prompts, more verbose feedback,
and more menus than you might see in a tool targeted at users interested
in or familiar with the computing-end of electronic communication. 

I'm not saying Pine's completely achieved it's ease of use goals.  There
are certainly some rough edges due to poor decisions early in development,
underlying technological limits and such, but we're always trying to
improve.  That said, thank's again for your comments, and if you have any
other specific concerns, please feel free to make them known to the Pine
Team <[email-masked]>. 

And now back to preparing for 3.91...  (due RSN)

Michael Seibel
Networks and Distributed Computing
University of Washington, Seattle

---

From: [email-masked] (John Stanley)
Date: 8 Oct 1994 18:30:16 GMT

In article <[email-masked]>,
>currently existing integrated mail and news readers would ignore it.

This is an advantage. It will prevent some "helpful" intermediate mailer
from redirecting a message someplace it wasn't wanted. Using current
systems, it is quite common for "Newsgroups:" to appear in a header of
something intended for mail only. It would be a violation of ethics for
a "helpful" intermediate mailer to take the existance of that header as
meaning "post this to the newsgroups listed."

>same name in news and mail.  

It doesn't mean the same thing, it should be named differently.

>After all, you do not have to rename

Those mean the same thing.

---

From: [email-masked] (Neil Rickert)
Date: 8 Oct 1994 15:33:23 -0500

>is misleading in situations where news & mail can't be distinguished.

That is plain wrong.

The "Newsgroups:" header is defined for news in RFC1036.  The use of
"Newsgroups" in email is not a violation of RFC1036.  It cannot be a
violation of RFC1036, since that document does not apply to mail.

The definition of headers for mail is given in RFC882.  The use of
"Newsgroups:" in an email message, for any reason at all, does not
contradict or violate anything in RFC882.

It has become common practice to use "Newsgroups:" as an email header
in replies to news articles.  If we were to disallow the development
of common practice and insist that no technological innovation occur
until after the RFC has been approved, we would probably still be
back in the dark ages.

>Besides, it's obviously bad practice to have the same header have two

As commonly used, the "Newsgroups:" header has only one
context-sensitive meaning.  That meaning is:

	when used for usenet postings, it lists the groups to which
	the message is posted; when used in email, it lists the
	usenet groups in which the discussion originated.

---

From: "Steven D. Majewski" <[email-masked]>
Date: Sat, 8 Oct 1994 18:40:44 -0400 (EDT)

> indicating a news article.

Not (always) true. 
( All my messages from [t]rn and tin are saved in mbox format. )

---

From: Rick Nebel <[email-masked]>
Date: Sat, 8 Oct 1994 18:53:11 -0500 (CDT)

My $.02.  I for one agree with Chris.  Of course if Mr. Rickert can write
a better mail package and provide on-going enhancements and support free
of charge I'm sure that everyone would be happy to move over to it. 

Rick Nebel

---

From: [email-masked] (Lachlan Cranswick)
Date: Sun, 9 Oct 1994 02:54:34 GMT

>poorly designed and mailers that do each of these 3 features better.

While I still use elm for much of my email (matter of
habit) - I was very
impressed with pine when I first came accross it
as our users obtained a user-friendly yet powerful
email program free.  And it was for our users that
pine was installed.  That must be saying something
about pine when users actually ask for it?

While there are now rivals to pine (can anyone name
a previous/present UNIX rival to pine?) examples of 
really good design are :-

---  The user-friendly and very powerful address book - including
creating lists.

---  For the  UNIX version - printing to a local PC or MAC printer.

---  Prompting and explanations of what the user is about
to do and error tolerant.

---  For UNIX - very easy and painless to compile - even on a 99% SUN
compatable Solbourne computer.

---  Availability of UNIX executables to save the hassle of
compiling.

---  Simple to use default editor.

---  For UNIX - stand alone binaries for simple installation.

---  Easy mailing and extracting of binary files.

---  For UNIX version - Nice file find and selecting procedure.

---  Easy access in latest version of pine for "power?" users.

------------------

The main part that confuses new users is :-

       I     FOLDER INDEX       -  View messages in current folder

       L     FOLDER LIST        -  Select a folder to view

but this is relatively easy to show how to use.

-------------------

While we use the latest version of pine for UNIX - we are
unsure about the MS-Windows version.  Mainly because
we would  like it to be transparently usable from any PC or 
telnet session for a user.  Because of the requirement
that the .sig and .address book have to be located
locally - this isn't easy for WinPine.

The easiest way to presently make it transparent for users
irrespective of what PC/MAC or terminal they are using
is to log into the email server via a telnet session and run
pine.

-
-- 
Lachlan Cranswick  -  CSIRO     _--_|\  [email-masked] 
Division of Mineral Products   /      \ tel +61 3 647 0367 
PO Box 124, Port Melbourne     \_.--._/ fax +61 3 646 3223 
3207 AUSTRALIA                       v

---

From: Mark Crispin <[email-masked]>
Date: Sun, 9 Oct 1994 20:48:24 -0700

> indicating a news article.

Uh, there are no ``From '' lines separating the messages in my mailbox. 
You must be thinking about a mailbox format that is used on some other 
system.

---

From: [email-masked] (Wayne Davison)
Date: Mon, 10 Oct 1994 06:19:24 GMT

According to Chris Newman  <[email-masked]>:
> such a meaning [in mail].

There is no specification of what the header means in mail, so your
interpretation is no more valid than mine.  However, mine is based on
the current use of at least 4 newsreaders, and thus is a better choice
than yours because I don't have to fight all that installed inertia.
-- 
Wayne Davison
[email-masked]

---

From: [email-masked] (Robert A. Rosenberg)
Date: Wed, 12 Oct 94 10:16:39 GMT

In Article <[email-masked]>, [email-masked]
>"X-Also-Mailed-To:" or "X-Also-Posted-To:" header in the generated

I'd feel better if the "X-Also-Mailed-To:" and "X-Also-Posted-To:" were
mandatory for post and mail cloned messages (ie: document that this
occurred).

---

From: [email-masked] (R. Stewart Ellis)
Date: 17 Oct 94 13:09:52 GMT

>You must be thinking about a mailbox format that is used on some other 

I give:  what is your platform and MTA?

-- 
  R.Stewart(Stew) Ellis, Assoc.Prof., (Off)313-762-9765   ___________________
  Humanities & Social Science,  GMI Eng.& Mgmt. Inst.    /   _____  ______ 
  Flint, MI 48504      [email-masked]               /        / /  /  / /
  Gopher,chimera,nn,tin,jove,modems, free code is best!/________/ /  /  / /

---

From: Mark Crispin <[email-masked]>
Date: Mon, 17 Oct 1994 20:13:39 -0700

> I give:  what is your platform and MTA?

BSD UNIX and sendmail.

This is an excellent example of why you must be careful about the type of
assumptions you make about how mail works.  Pine is used with at least
nine different local storage formats, and at least four network protocols. 
The format which uses ``From '' lines is just one of these.  The format
commonly called ``news'' is another.